//@input Component.Text wordText;
//@input Component.Text typeAndPronunciationText;
//@input Component.Text definitionsText;
//@input Component.Text dateText;

// This will use FallbackData if global.launchParams has not been filled out 
var launchParams = global.launchParams;

/* Storage accessors */
var word;
var type;
var pronunciation;
var definitions;
var date;  

var storageKeys = ["word_of_the_day","type","pronunciation","definitions", "date"]

/****************/
function getData() {
    if (launchParams) {
        if (launchParams.has(storageKeys[0]) &&
            launchParams.has(storageKeys[1]) &&
            launchParams.has(storageKeys[2]) &&
            launchParams.has(storageKeys[3]) && 
            launchParams.has(storageKeys[4])) {
            
            word = launchParams.getString(storageKeys[0]);
            type = launchParams.getString(storageKeys[1]);
            pronunciation = launchParams.getString(storageKeys[2]);
            definitions = launchParams.getStringArray(storageKeys[3]);
            date = launchParams.getFloatArray(storageKeys[4]);
            return true;
        }
        
    return false;
    }
}

function populateFields() {
    
    script.wordText.text = word;
    script.typeAndPronunciationText.text = type + " | " + pronunciation;
    script.definitionsText.text = "";
    
    for(var i in definitions) {
        script.definitionsText.text += (parseInt(i) + 1) + ". " +definitions[i] + '\n';
    }
    
    setDate();
}

function setDate() {
    
    if(date.length == 3 && date[1] < 12) {
        script.dateText.text = global.localizationSystem.getDateFormatted(new Date(date[0], date[1] -1, date[2]));      
    } else {
        print("Error: Incorrect date passed in, should be [year, month, day]. Today's date will be used instead");
        script.dateText.text = global.localizationSystem.getDateFormatted(new Date());
    }
    
}


if(getData()) { 
    populateFields();
} else {
    print("Failed to get Data");
}